package cn.jisol.game.controller.game;

import cfg.TB.TbGGlobal;
import cn.hutool.json.JSONUtil;
import cn.jisol.game.controller.argsresolver.CurrentPlayer;
import cn.jisol.game.data.GlobalId;
import cn.jisol.game.data.TD;
import cn.jisol.game.entity.game.Player;
import cn.jisol.game.entity.game.PlayerPet;
import cn.jisol.game.service.PlayerPetService;
import cn.jisol.ngame.util.NewsContext;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Objects;

@Api(value = "JNGameDemo - API", tags = {"新手引导 - API"})
@RestController
@RequestMapping("/game/novice")
@ResponseBody
public class GNoviceController {

    @Autowired
    PlayerPetService playerPetService;

    //选择宠物(前提是玩家没有宠物)
    @ApiImplicitParams({})
    @ApiOperation(value = "选择宠物(前提是玩家没有宠物)")
    @PostMapping("/select/{petId}")
    public NewsContext<PlayerPet> select(@CurrentPlayer Player player,@PathVariable Integer petId){

        if(Objects.isNull(petId)) return NewsContext.onFail("请选择宠物");
        //判断选择的宠物是否在配置表中
        TbGGlobal info = TD.DATA.getTbGGlobal().get(GlobalId.SELECT_PET_ID);
        //判断选择的宠物是否在其中
        List<Integer> ids = JSONUtil.toList(info.args, Integer.class);
        if (!ids.contains(petId)) return NewsContext.onFail("不可选择这个宠物!");

        //宠物数量
        long petCount = playerPetService.count(
                Wrappers.lambdaQuery(PlayerPet.class).eq(PlayerPet::getPetPlayerId,player.getPlayerId())
        );

        if(petCount > 0){
            //玩家已经有宠物了
            return NewsContext.onFail("你已经有宠物了!");
        }else{
            //选择宠物
            if (playerPetService.save(PlayerPet.builder().petPlayerId(player.getPlayerId()).petTbId(petId).petLevel(0).build())){
                return NewsContext.onSuccess("选择宠物成功");
            }else{
                return NewsContext.onSuccess("选择宠物失败");
            }
        }

    }

}
