package cn.jisol.game.vo.news;

import cn.jisol.game.entity.game.Resource;
import cn.jisol.game.vo.news.ov.ResourceUpdateOV;
import cn.jisol.ngame.util.NewsContext;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import lombok.Builder;
import lombok.experimental.SuperBuilder;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


//返回带资源更新的消息
@SuperBuilder
@ApiResponses({
    @ApiResponse(code = 200,message = "成功"),
    @ApiResponse(code = 500,message = "失败"),
})
public class NewsResource<T> extends NewsContext<T> {

    //资源刷新
    public List<ResourceUpdateOV> resources = new ArrayList<>();

    //添加一个刷新资源数据
    public void addUpdateResource(Resource resource){
        this.resources.add(ResourceUpdateOV.onUpdate(resource));
    }

    public static <T> NewsResource<T> onSuccess(String msg){
        return onMessage(msg,null,NEWS_STATE_SUCCESS,new ArrayList<>());
    }
    public static <T> NewsResource<T> onSuccess(String msg,T data){
        return onMessage(msg,data,NEWS_STATE_SUCCESS,new ArrayList<>());
    }
    public static <T> NewsResource<T> onSuccess(String msg,T data,ResourceUpdateOV... resource){
        return onMessage(msg,data,NEWS_STATE_SUCCESS, Arrays.asList(resource));
    }

    public static <T> NewsResource<T> onFail(String msg){
        return onMessage(msg,null,NEWS_STATE_FAIL,new ArrayList<>());
    }
    public static <T> NewsResource<T> onFail(String msg, T data){
        return onMessage(msg,data,NEWS_STATE_FAIL,new ArrayList<>());
    }

    public static <T> NewsResource<T> onMessage(String msg, T data, Integer state,List<ResourceUpdateOV> resource){
        return (NewsResource<T>) NewsResource.builder().state(state).msg(msg).data(data).resources(resource).build();
    }

}
