package cn.jisol.game.vo.news.ov;

import cn.jisol.game.entity.game.PlayerPet;
import cn.jisol.game.entity.game.Resource;
import lombok.Builder;
import lombok.Data;

//资源更新类
@Builder
@Data
public class ResourceUpdateOV {

    Resource resource;          //资源
    PlayerPet pet;              //宠物

    //操作
    int operation = 0;

    //资源更新类型
    public interface ResourceUpdateType{
        static int UPDATE = 0;  //刷新资源数量
        static int MINUS = 1;   //减少资源数量
        static int ADD = 2;     //添加资源数量
    }

    //返回一个刷新的资源更新类
    public static ResourceUpdateOV onUpdate(Resource resource){
        return ResourceUpdateOV.builder().operation(ResourceUpdateType.UPDATE).resource(resource).build();
    }

    //返回宠物
    public static ResourceUpdateOV onPet(int type,PlayerPet pet){
        return ResourceUpdateOV.builder().operation(type).pet(pet).build();
    }

}
